<?php
class Plugincompany_HookCompany extends Hook {
	public function RegisterHook() {
		$this->AddHook('topic_add_before', 'TopicBeforeAdd', __CLASS__, -5);
		$this->AddHook('topic_add_after', 'TopicAfterAdd', __CLASS__, -5);
		$this->AddHook('topic_edit_after', 'TopicAfterEdit', __CLASS__, -5);

		$this->AddHook('template_main_menu_item', 'tplMainMenu', __CLASS__, 2);
		$this->AddHook('template_menu_profile_created_item', 'tplMenuCreatedProfile', __CLASS__, -5);
		$this->AddHook('template_menu_profile_favourite_item', 'tplMenuFavProfile', __CLASS__, -5);

		$this->AddHook('template_profile_whois_activity_item', 'tplProfileWhois', __CLASS__, -5);
		$this->AddHook('template_menu_blog', 'tplMenuBlog', __CLASS__, -5);
		$this->AddHook('template_search_result_item', 'tplSearchItem', __CLASS__, -5);
		$this->AddHook('template_search_result', 'tplSearch', __CLASS__, -5);
		$this->AddHook('template_menu_create_item', 'tplCreateItem', __CLASS__, -5);
		$this->AddHook('template_menu_create_item_select', 'tplCreateItemSelect', __CLASS__, -5);
		$this->AddHook('action_shutdown_actionindex_after', 'ActionShutdown', __CLASS__, -5);
		if (Config::Get('module.company.feedbacks_in_stream'))
			$this->AddHook('template_block_stream_nav_item', 'tplBlockStreamItem', __CLASS__, -5);
		//$this->AddHook('template_write_item', 'tplWriteItem', __CLASS__, -5);

		/*	$this->AddHook('action_shutdown_actionpersonalblog_after', 'ActionShutdown', __CLASS__, -5);
		  $this->AddHook('action_shutdown_actiontop_after', 'ActionShutdown', __CLASS__, -5);
		  $this->AddHook('action_shutdown_actionblog_after', 'ActionShutdown', __CLASS__, -5);
		  $this->AddHook('action_shutdown_actionnew_after', 'ActionShutdown', __CLASS__, -5);
  */
	}




	/**
	 * Добавляет элемент в меню "Создать"
	 * @param $aVars
	 * @return mixed
	 */
	public function tplCreateItem($aVars) {
		return $this->Viewer_Fetch(Plugin::GetTemplatePath(__CLASS__).'/inject.menu.create.content.tpl');
	}
	/**
	 * Добавляет элемент в меню выбора "Создать"
	 * @param $aVars
	 * @return mixed
	 */
	public function tplCreateItemSelect($aVars) {
		if ($aVars["sMenuItemSelect"]=='company')
			return $this->Lang_Get('plugin.company.company_menu_create');
	}
	/**
	 * Вкладка поиска компании
	 * @param $aVars
	 * @return mixed
	 */
	public function tplSearchItem($aVars) {
		if ($aVars["sType"]=='companies')
			return $this->Lang_Get('plugin.company.search_results_count_companies');
	}
	/**
	 * Отображение результатов поиска
	 * @param $aVars
	 * @return mixed
	 */
	public function tplSearch($aVars) {
		if ($aVars["sType"]=='companies')
			return $this->Viewer_Fetch(Plugin::GetTemplatePath(__CLASS__).'/company_list.tpl');
	}

	/**
	 * Выводит сразу на главную топики компаний, если устрановлена настройка.
	 * @param $aVars
	 * @return mixed
	 */
	public function TopicBeforeAdd($aVars) {
		if ($aVars["oBlog"]->getType()=='company'){
			// Топики компаний сразу попадают на главную
			if (Config::Get('module.company.topic_on_index')){
				$aVars["oTopic"]->setPublishIndex(1);
			}
		}
	}
	/**
	 * Отправляет подписчикам компании уведомления о новом топике
	 * @param $aVars
	 * @return mixed
	 */
	public function TopicAfterAdd($aVars) {
		if ($aVars["oBlog"]->getType()=='company' and $aVars["oTopic"]->getPublish()){
			$this->PluginCompany_Company_SendSubscribeNewTopic($aVars["oTopic"]);
			$oCompany = $this->PluginCompany_Company_GetCompanyByBlogId($aVars["oTopic"]->getBlogId());
			$oCompany->setTopicIdLast($aVars["oTopic"]->getId());
			$this->PluginCompany_Company_UpdateCompany($oCompany);
		}
	}

	/**
	 * Регулирует последний топик компании после редактирования
	 * @param $aVars
	 * @return mixed
	 */
	public function TopicAfterEdit($aVars) {
		if ($aVars["oBlog"]->getType()=='company'){
			$this->PluginCompany_Company_SendSubscribeNewTopic($aVars["oTopic"]);
			$oCompany = $this->PluginCompany_Company_GetCompanyByBlogId($aVars["oTopic"]->getBlogId());
			if ($oTopic = $this->Topic_GetLastBlogTopic($oCompany->getBlogId())){
				$oCompany->setTopicIdLast($oTopic->getId());
			} else{
				$oCompany->setTopicIdLast(0);
			}
			$this->PluginCompany_Company_UpdateCompany($oCompany);
		}
	}
	/**
	 * Добавляет "Компании" в главное меню
	 * @param $aVars
	 * @return mixed
	 */
	public function tplMainMenu($aVars) {
		return $this->Viewer_Fetch(Plugin::GetTemplatePath(__CLASS__).'/inject.header_top.tpl');
	}
	/**
	 * Добавляет в публикации профиля меню с отзывами
	 * @param $aVars
	 * @return mixed
	 */
	public function tplMenuCreatedProfile($aVars) {
		return $this->Viewer_Fetch(Plugin::GetTemplatePath(__CLASS__).'/inject.menu.profile_created.tpl');
	}

	/**
	 * Добавляет в избранное профиля меню с компаниями
	 * @param $aVars
	 * @return mixed
	 */
	public function tplMenuFavProfile($aVars) {
		return $this->Viewer_Fetch(Plugin::GetTemplatePath(__CLASS__).'/inject.menu.profile_favourite.tpl');
	}

	/**
	 * Добавляет переменные с количеством топиков
	 * @param $aVars
	 * @return mixed
	 */
	public function ActionShutdown($aVars) {

		$iCountTopicsCollectiveNew=$this->Topic_GetCountTopicsCollectiveNew();
		$iCountTopicsPersonalNew=$this->Topic_GetCountTopicsPersonalNew();
		$iCountTopicsCompanyNew=$this->Topic_GetCountTopicsCorporativeNew();
		$iCountTopicsNew=$iCountTopicsCollectiveNew+$iCountTopicsPersonalNew+$iCountTopicsCompanyNew;

		$this->Viewer_Assign('iCountTopicsCompanyNew',$iCountTopicsCompanyNew);
		$this->Viewer_Assign('iCountTopicsPersonalNew',$iCountTopicsPersonalNew);
		$this->Viewer_Assign('iCountTopicsNew',$iCountTopicsNew);
	}

	/**
	 * Добавляет данные в профиль пользователя по созданным компаниям и отношения к компаниям
	 * @param $aVars
	 * @return mixed
	 */
	public function tplProfileWhois($aVars) {
		$aCompanyEmployee = $this->PluginCompany_Company_GetCompaniesByUser($aVars["oUserProfile"]->getId());
		$aResult=$this->PluginCompany_Company_GetFavouriteCompaniesByUserId($aVars["oUserProfile"]->getId(),1,100);
		$aCompanyAdmirer=$aResult['collection'];
		$this->Viewer_Assign('aCompanyEmployee',$aCompanyEmployee);
		$this->Viewer_Assign('aCompanyAdmirer',$aCompanyAdmirer);
		return $this->Viewer_Fetch(Plugin::GetTemplatePath(__CLASS__).'/inject.whois.tpl');
	}

	/**
	 * Добавляет в меню блогов "Корпоративные" топики
	 * @param $aVars
	 * @return mixed
	 */
	public function tplMenuBlog($aVars) {
		return $this->Viewer_Fetch(Plugin::GetTemplatePath(__CLASS__).'/inject.menu.blog.tpl');
	}

	public function tplBlockStreamItem($aVars) {
		return $this->Viewer_Fetch(Plugin::GetTemplatePath(__CLASS__).'/inject.stream_feedback.tpl');
	}


	/*
public function tplWriteItem($aVars) {
	return $this->Viewer_Fetch(Plugin::GetTemplatePath(__CLASS__).'/inject.menu.create.content.tpl');
}
*/
}
?>