<?php
/**
 * ACL(Access Control List)
 * Модуль для разруливания ограничений по карме/рейтингу юзера
 *
 */
class PluginCompany_ModuleACL extends PluginCompany_Inherit_ModuleACL {

	/*
	 * Проверяет может ли пользователь создавать компании
	 */
	public function CanCreateCompany(ModuleUser_EntityUser $oUser) {
		if ($oUser->getRating()>=Config::Get('acl.create.company.rating') or $oUser->isAdministrator()) {
			return true;
		}
		return false;
	}

	/*
     * Проверяет может ли пользователь редактировать компании
    */
	public function CanEditCompany(ModuleUser_EntityUser $oUser, PluginCompany_ModuleCompany_EntityCompany $oCompany) {
		if ($oCompany->getOwnerId()==$oUser->getId() or $oUser->isAdministrator() or $oCompany->getUserIsAdministrator()) {
			return true;
		}
		return false;
	}
	/*
	 * Проверяет может ли пользователь голосовать за конкретный блог
	 */
	public function CanVoteCompany(ModuleUser_EntityUser $oUser, PluginCompany_ModuleCompany_EntityCompany $oCompany) {
		if ($oUser->getRating()>=Config::Get('acl.vote.company.rating') or $oUser->isAdministrator()) {
			return true;
		}
		return false;
	}

	/*
	 * Проверяет может ли пользователь писать отзывы
	 */
	public function CanPostFeedback(ModuleUser_EntityUser $oUser) {
		if ($oUser->getRating()>=Config::Get('acl.create.feedback.rating') or $oUser->isAdministrator()) {
			return true;
		}
		return false;
	}

	/*
	 * Проверяет можно ли просматривать компанию
	 */
	public function CanViewCompany($oUser, PluginCompany_ModuleCompany_EntityCompany $oCompany) {
		if (Config::Get('module.company.use_activate') and !$oCompany->getActive()) {
			if (!$oUser or ($oCompany->getOwnerId() != $oUser->getId() and !$oUser->isAdministrator()))
				return false;
		}
		return true;
	}
}
?>