<?php
/**
 * Модуль для работы с блогами
 *
 */

class PluginCompany_ModuleBlog extends PluginCompany_Inherit_ModuleBlog {
	public function GetInaccessibleBlogsByUser($oUser=null) {
		$aCloseBlogs = parent::GetInaccessibleBlogsByUser($oUser);
		$aCloseInactiveBlogs = $this->PluginCompany_Company_GetInaccessibleCompanyBlogs();
		return array_merge($aCloseBlogs,$aCloseInactiveBlogs);
	}

    public function GetBlogsAllowByUser($oUser) {
        $aAllowBlogsUser = parent::GetBlogsAllowByUser($oUser);
        //если используется активация то отдаем только блоги активированных компаний
        if (Config::Get('module.company.use_activate') and !$oUser->isAdministrator()) {
            $aInaccessible = $this->GetInaccessibleBlogsByUser($oUser);
            $aReturn = array();
            foreach ($aAllowBlogsUser as $aRow) {
                if ($aRow->getType() <> 'company' or !in_array($aRow->getId(),$aInaccessible))
                    $aReturn[$aRow->getId()]=$aRow;
            }
            return $aReturn;
        }
        return $aAllowBlogsUser;
    }
}
?>