<?php
class PluginCompany_ModuleGeo extends PluginCompany_Inherit_ModuleGeo {
	public function CheckTargetCompany(){
		return true;
	}


	public function GetCompaniesByFilter($aFilter,$aOrder,$iCurrPage,$iPerPage,$aAllowData=null) {
		// если используется активация, то показываем только активированные
		if (Config::Get('module.company.use_activate') and !isset($aFilter['active']))
			$aFilter['active'] = 1;
		$sKey="companies_filter_".serialize($aFilter).serialize($aOrder)."_{$iCurrPage}_{$iPerPage}";
		if (false === ($data = $this->Cache_Get($sKey))) {
			$data = array('collection'=>$this->oMapper->GetCompaniesByFilter($aFilter,$aOrder,$iCount,$iCurrPage,$iPerPage),'count'=>$iCount);
			$this->Cache_Set($data, $sKey, array("company_update","company_new"), 60*60*24*2);
		}
		$data['collection']=$this->GetCompaniesAdditionalData($data['collection'],$aAllowData);
		return $data;
	}

	public function GetCompanyTargets($aFilter,$iCurrPage,$iPerPage) {
		$sKey="companies_targets_".serialize($aFilter)."_{$iCurrPage}_{$iPerPage}";
		if (false === ($data = $this->Cache_Get($sKey))) {
			$data = array('collection'=>$this->oMapper->GetTargets($aFilter,$iCount,$iCurrPage,$iPerPage),'count'=>$iCount);
			$this->Cache_Set($data, $sKey, array("company_update","company_new"), 60*60*24);
		}
		return $data;
	}


	public function GetCompanyTargetsByArray($aTargetId) {
		if (!is_array($aTargetId)) {
			$aTargetId=array($aTargetId);
		}
		if (!count($aTargetId)) {
			return array();
		}
		$aResult=array();
		$aTargets=$this->GetCompanyTargets(array('target_type'=>'company','target_id'=>$aTargetId),1,count($aTargetId));
		if ($aTargets['count']) {
			foreach($aTargets['collection'] as $oTarget) {
				$aResult[$oTarget->getTargetId()][]=$oTarget;
			}
		}
		return $aResult;
	}
}