<?php
/**
 *	Module "Company"
 *	Author: Grebenkin Anton
 *	Contact e-mail: 4freework@gmail.com
 */

/**
 * Конфиг плагина "company" - Компании
 */
Config::Set('acl.vote.company.rating', -1); 		// порог рейтинга при котором юзер может голосовать за компанию
Config::Set('acl.create.feedback.rating', -5);		// порог рейтинга при котором юзер может добавлять отзыв
Config::Set('acl.create.company.rating', 0);		// порог рейтинга при котором пользователь может создать компанию

Config::Set('module.company.per_page', 20); 		// количество компаний на странице
Config::Set('module.company.on_block', 10);			// количество отображаемое в блоке
Config::Set('module.company.use_jobs', true);		// используется ли плагин Работа
Config::Set('module.company.description_len', 255); // количество символов описание в компаний
Config::Set('module.company.about_len', 3000);       // количество символов в поле о компаний
Config::Set('module.company.new_time', 60*60*24*7); // сколько времени компания считается новой

Config::Set('module.company.topic_on_index', true);	// выводить все новые топики из блогов компаний на главную
Config::Set('module.company.feedbacks_in_stream', false); // выводить отзывы компаний в прямой эфир
Config::Set('module.company.use_category', false);      // Вместо тэгов выводить категории.
Config::Set('module.company.prefix', 'company'); 	// префикс для компаний (ссылка в URL)
Config::Set('module.company.image_web_path', '___path.root.web______path.uploads.images___/company/'); // путь до логотипов компании
Config::Set('module.company.use_activate', false);			// используется премодерация компаний
Config::Set('module.company.use_convert_url', false);		// используется ли автоматическое создание URL по названию компании
Config::Set('module.company.allow_file_ext', array('doc','docx','xls','xlsx', 'pdf'));		// типы файлов которые позволяем загружать
Config::Set('module.company.types', array('base'));	// Можно задавать типы компаний и для них делать различный набор полей.

// Тип карты. Возможные значения:
// openstreet#map (Open Street Map);
// yandex#map (схема)
// yandex#publicMap (народная карта); - по умолчанию;
// google#map (Google.Схема)
// mail#map (Mail.Схема);
Config::Set('module.company.map.use', true);				// позволять ли компаниям указывать координаты на карте
Config::Set('module.company.map.type', "yandex#publicMap"); // тип отображения карты
Config::Set('module.company.map.edit_zoom', 9); 			// зум при редактировании компании
Config::Set('module.company.map.view_zoom', 15); 			// зум при отображении карты в профиле
Config::Set('module.company.map.scroll', false); 			// разрешать ли менять размер карты скролом мышки
Config::Set('module.company.map.center', "[37.5607,55.8672]"); // центр карты
Config::Set('module.company.map.geocode', true);			// Использовать ли геокодирование (ищет по адресу местонахождение компании при редактировании)


// настройки загрузки логотипа
$config['module']['image']['company_logo']['jpg_quality']		= 100;
$config['module']['image']['company_logo']['watermark_use']		= false;
$config['module']['image']['company_logo']['round_corner']		= false;
Config::Set('module.company.logo_size', array(100,48,24,0)); // Список размеров логотипов компаний. 0 - исходный размер


/**
 * Настройки фотографий
 */
Config::Set('module.company.photo.jpg_quality', 100);        // настройка модуля Image, качество обработки фото
Config::Set('module.company.photo.photo_max_size', 6*1024);  // максимально допустимый размер фото, Kb
Config::Set('module.company.photo.count_photos_min', 0);     // минимальное количество фоток
Config::Set('module.company.photo.count_photos_max', 30);    // максимальное количество фоток
Config::Set('module.company.photo.per_page', 21);            // число фоток при загрузке
Config::Set('module.company.photo.size', array(             // список размеров превью, которые необходимо делать при загрузке фото
	array(
		'w' => 1000,
		'h' => null,
		'crop' => false,
	),
	array(
		'w' => 300,
		'h' => null,
		'crop' => false,
	),
	array(
		'w' => 100,
		'h' => 65,
		'crop' => true,
	),
	array(
		'w' => 50,
		'h' => 50,
		'crop' => true,
	)
));
/** Список тарифов
 * нулевой тариф всегда считается бесплатным и без времени
 * доступные права.
 * 'branding' возможность брендировать страницу
 * 'photo' возможность загружать фотографии в альбом компании
 * 'widgets' возможность пользоваться виджетами
 */
Config::Set('module.company.tariffs', array(
	array(
		'id' => 0,
		'title' => 'Free',
		'rights' => array('photo'), // доступные действия
	),
	array(
		'id' => 1,
		'title' => 'Бизнес',
		'rights' => array('branding','photo','widgets'),
	),
));

Config::Set('module.company.tariff_periods', array(30,90,365));  // варианты продления тарифа, количество дней

// Настройки авторизации твиттера https://dev.twitter.com/apps
Config::Set('module.company.twitter.oauth_access_token', ''); //access token
Config::Set('module.company.twitter.oauth_access_token_secret', ''); // access token secret
Config::Set('module.company.twitter.consumer_key', ''); //consumer key
Config::Set('module.company.twitter.consumer_secret', ''); // consumer secret



// настройки руотинга
Config::Set('router.page.company', 'PluginCompany_ActionCompany');
Config::Set('router.page.companies', 'PluginCompany_ActionCompanies');

// если поменяли префикс то подменяем ссылки действий
if (Config::Get('module.company.prefix') != 'company'){
	Config::Set('router.rewrite.company', '___module.company.prefix___');
}
//Config::Set('router.rewrite.companies', 'НаКакойУРЛПоменять');
// описание таблиц компаний
Config::Set('db.table.company', 			'___db.table.prefix___company');
Config::Set('db.table.company_tag', 		'___db.table.prefix___company_tag');
Config::Set('db.table.company_feedback_read', '___db.table.prefix___company_feedback_read');
Config::Set('db.table.company_photo', 		'___db.table.prefix___company_photo');
Config::Set('db.table.staff', 		'___db.table.prefix___company_staff');

// Блоки которые будут на всех страницах компаний
Config::Set('block.plugin_companies', array(
    'action' => array(
       'companies'
    ),
    'blocks' => array(
        'right' => array(
            /*'stream'=>array('priority'=>100),*/
			'feedbacks' => array('params' => array('plugin' => 'company'), 'priority' => 4),
            'tags' => array('params' => array('plugin' => 'company'), 'priority' => 5),
            'tagsCountry' => array('params' => array('plugin' => 'company'), 'priority' => 2),
            'tagsCity' => array('params' => array('plugin' => 'company'), 'priority' => 1),
        )
    ),
    'clear' => false,
));

Config::Set('block.company_widgets', array(
	'action' => array(
		'company' => array('{topic}','{profile}','{blog}','{vacancies}','{feedbacks}','{fans}',)
	),
	'blocks' => array(
		'right' => array(
			'widgets' => array('params' => array('plugin' => 'company'), 'priority' => 100),
		)
	),
	'clear' => false,
));
Config::Set('block.plugin_company', array(
	'action' => array(
		'company'
	),
	'blocks' => array(
		'right' => array(
			'companyinfo' => array('params' => array('plugin' => 'company'), 'priority' => 110),
		)
	),
	'clear' => false,
));

?>