var ls = ls || {};

ls.company = (function ($) {
	this.toggleJoin = function(obj,idBlog) {   
		ls.ajax(aRouter['company']+'ajax/joinleavecompany/',{idBlog: idBlog},function(result) {
			if (result.bStateError) {
				ls.msg.error(null, result.sMsg);
			} else {
				obj = $(obj);
				ls.msg.notice(null, result.sMsg);
				obj.removeClass("active");
                obj.text(ls.lang.get('plugin.company.company_work'));
				if (result.bState) {
					obj.addClass("active");
                    obj.text(ls.lang.get('plugin.company.company_dont_work'));
				}
				$('#blog_user_count_'+idBlog).text(result.iCountUser);
			}
		});
	}

    this.autocomplete = function(obj, sPath) {
        obj.autocomplete({
            source: function(request, response) {
                ls.ajax(sPath,{value: request.term},function(data){
                    response(data.aItems);
                });
            },
            select: function( event, ui ) {
                location.href=aRouter['company'] + ui.item.company_url +'/';
            }
        })
            .data( "autocomplete" )._renderItem = function( ul, item ) {
            return $( "<li></li>" )
                .data( "item.autocomplete", item )
                .append( "<a><img src='"+item.company_logo+"' height='20px' style='vertical-align: middle'> " + item.company_name +"</a>" )
                .appendTo( ul );
        };
    }

    this.addStaff = function() {
        var forms = $('.company .staff-form');
        if(forms.length>1) {
            var id = forms[forms.length-2].id.match(/\d+/g)[0];
            id = parseInt(id);
        }else {
            var id = 0;
        }
        id++;
        var form = $('#staff-form-form_id');
        $(form).clone().appendTo('#staff-forms-holder');
        var first_form = $('#staff-form-form_id:first');
        first_form.removeClass('hidden');
        first_form.attr('id', first_form.attr('id').replace(/form_id/,id));
        first_form.html(first_form.html().replace(/form_id/g,id));
        return false;
    }
    this.closeStaff = function(id) {
        $('#staff-form-' + id).remove();
        return false;
    }

	
    this.toggleWidget = function(name) {
        var widget = $('#widget-'+name);
        if (widget.is(':visible')) {
            widget.hide();
        } else {
            widget.show();
        }

        return false;
    };

    this.updateTwitter = function(screenName) {
        idCompany = $('#company_id').val();
        var url = aRouter['company']+'ajax/update-twitter/';
        var params = {screenName: screenName, idCompany: idCompany};
        ls.ajax(url, params, function(result){
            if (result.bStateError) {
                ls.msg.error(null, result.sMsg);
            } else {
                ls.msg.notice(null, result.sMsg);
            }
        });
    };

    this.checkVk = function(vk_url) {
        aUrl = vk_url.split('/');
        screenName = aUrl[aUrl.length-1];
        $.ajax({
            url: 'http://api.vk.com/method/groups.getById?gid='+encodeURIComponent(screenName)+'&callback=jsonpCallback',
            type: 'post',
            dataType: 'jsonp',
            success: function jsonpCallback(data){
                var id = parseInt(data.response[0].gid);
            }
        });
    };

    this.updateVk = function(vk_url) {
        aUrl = vk_url.split('/');
        vkUrl = aUrl[aUrl.length-1];
        idCompany = $('#company_id').val();
        var url = aRouter['company']+'ajax/update-vk/';
        var params = {vkUrl: vkUrl, idCompany: idCompany};
        ls.ajax(url, params, function(result){
            if (result.bStateError) {
                ls.msg.error(null, result.sMsg);
            } else {
                ls.msg.notice(null, result.sMsg);
            }
        });
    };

    this.updateFb = function(fb_url) {
        aUrl = fb_url.split('/');
        fbUrl = aUrl[aUrl.length-1];
        idCompany = $('#company_id').val();
        var url = aRouter['company']+'ajax/update-fb/';
        var params = {fbUrl: fbUrl, idCompany: idCompany};
        ls.ajax(url, params, function(result){
            if (result.bStateError) {
                ls.msg.error(null, result.sMsg);
            } else {
                ls.msg.notice(null, result.sMsg);
            }
        });
    };

    this.switchWidgetVisible = function (widgetName) {
        var idCompany = $('#company_id').val();
        var iVisible = $("#visible-"+widgetName).attr("checked")=="checked";

        var url = aRouter['company']+'ajax/switch-widget-visible/';
        var params = {widgetName: widgetName, idCompany: idCompany, iVisible: iVisible};

        ls.ajax(url, params, function(result){
            if (result.bStateError) {
                ls.msg.error(null, result.sMsg);
            } else {
                ls.msg.notice(null, result.sMsg);
            }
        });

    };


    this.getJSON = function(url){
        var resultJSON = null;
        var http_request = new XMLHttpRequest();
        http_request.open( "GET", url, true );
        http_request.send(null);
        http_request.onreadystatechange = function () {
            if ( http_request.readyState == 4 ) {
                if ( http_request.status == 200 ) {
                    resultJSON = JSON.parse(http_request.responseText);
                    ls.msg.notice(null, 'Успешно получены данные');
                   // return result;
                } else {
                    ls.msg.error(null, 'Неверное значение');
                }
                http_request = null;
            }
        };

    };


    this.updateTariff = function (formObj) {
        formObj = $('#'+formObj);

        var url = aRouter['company']+'ajax/tariff-update/';

        ls.ajax(url, formObj.serializeJSON(), function(result){
            if (result.bStateError) {
                ls.msg.error(null, result.sMsg);
            } else {
                if (result.sDate){
                    $('#tariff_end_date').text(result.sDate);
                    $('#tariff_end_date').removeClass("hidden");
                }else {
                    $('#tariff_end_date').addClass("hidden");
                }
                ls.msg.notice(null, result.sMsg);
            }
        });

    };
	
	
	return this;
}).call(ls.company || {},jQuery);



ls.vote.options.type.company = { url: aRouter['company']+'ajax/votecompany/', targetName: 'idCompany' };
ls.favourite.options.type.company = { url: aRouter['company']+'ajax/favourite/', targetName: 'idCompany' };

ls.hook.add ('ls_template_init_start', function (obj, block) {
    $('.js-company-tag-search-form').submit(function(){
        var val=$(this).find('.js-company-tag-search').val();
        if (val) {
            window.location = aRouter['companies']+'tag/'+encodeURIComponent(val)+'/';
        }
        return false;
    });
    ls.autocomplete.add($(".autocomplete-company-tags"), aRouter['company']+'ajax/autocompleter/tag/', false);
});


ls.hook.add('ls_favourite_toggle_after',function(idTarget,objFavourite,type,params,result){
    $('#fav_count_'+type+'_'+idTarget).text((result.iCount > 0) ? result.iCount : '');
    
    if (type == 'company' ) {
        if (result.bState) {
            this.objFavourite.text(ls.lang.get('vote_dont_like'));
        } else {
            this.objFavourite.text(ls.lang.get('vote_like'));
        }
    }
});


ls.hook.add ('ls_subscribe_toggle_after', function (sTargetType, iTargetId, sMail, iValue) {
    if (iValue == 1){
        $('#unsubscribeCompany').removeClass("hidden");
        $('#subscribeCompany').addClass("hidden");
    }else {
        $('#subscribeCompany').removeClass("hidden");
        $('#unsubscribeCompany').addClass("hidden");
    }
    // обработчиков ошибок нет, т.к. подписка уже прошла, значит все ок
    ls.ajax(aRouter['company']+'ajax/subscribe-toggle/',{idCompany: iTargetId, iValue: iValue},function(result) {
    });
});